(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { combineReducers } from 'redux';

import { reducer as categoryTrees } from '../category-trees';

import { reducer as datasets } from '../dataset';

import { reducer as tooltip } from '../tooltip';

import '../pane';

import { reducer as startup } from '../startup';
import { buildPanesReducer } from '../pane/reducer';
import { reducer as queryGroupModal } from '../query-group-modal';
import { reducer as previousQueries } from '../previous-queries/list';
import { reducer as previousQueriesSearch } from '../previous-queries/search';
import { reducer as previousQueriesFilter } from '../previous-queries/filter';
import { reducer as uploadQueryResults } from '../previous-queries/upload';
import { reducer as deletePreviousQueryModal } from '../previous-queries/delete-modal';
import { reducer as uploadConceptListModal } from '../upload-concept-list-modal';

import { createQueryNodeEditorReducer } from '../query-node-editor';

var buildAppReducer = function buildAppReducer(tabs) {
  return combineReducers({
    startup: startup,
    categoryTrees: categoryTrees,
    uploadConceptListModal: uploadConceptListModal,
    queryNodeEditor: createQueryNodeEditorReducer('standard'),
    queryGroupModal: queryGroupModal,
    datasets: datasets,
    tooltip: tooltip,
    panes: buildPanesReducer(tabs),
    previousQueries: previousQueries,
    previousQueriesSearch: previousQueriesSearch,
    previousQueriesFilter: previousQueriesFilter,
    uploadQueryResults: uploadQueryResults,
    deletePreviousQueryModal: deletePreviousQueryModal
  });
};

var _default = buildAppReducer;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(buildAppReducer, 'buildAppReducer', '/home/travis/build/bakdata/conquery/frontend/lib/js/app/reducers.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/app/reducers.js');
  leaveModule(module);
})();

;