(function () {
    var enterModule = require('react-hot-loader').enterModule;

    enterModule && enterModule(module);
})();

export var readFileAsText = function readFileAsText(file) {
    return new Promise(function (resolve, reject) {
        var reader = new FileReader();

        reader.onload = function (evt) {
            return resolve(evt.target.result);
        };
        reader.onerror = function (err) {
            return reject(err);
        };

        reader.readAsText(file);
    });
};

/**
 * Split by \n, trim rows and filter empty rows
 * @param fileContent
 */
export var cleanFileContent = function cleanFileContent(fileContent) {
    return fileContent.split('\n').map(function (row) {
        return row.trim();
    }).filter(function (row) {
        return row.length > 0;
    });
};

export var checkFileType = function checkFileType(file, type) {
    return file.type === type || "text/plain";
};

export var stripFileName = function stripFileName(fileName) {
    return fileName.replace(/\.[^/.]+$/, "");
};
;

(function () {
    var reactHotLoader = require('react-hot-loader').default;

    var leaveModule = require('react-hot-loader').leaveModule;

    if (!reactHotLoader) {
        return;
    }

    reactHotLoader.register(readFileAsText, "readFileAsText", "/home/travis/build/bakdata/conquery/frontend/lib/js/common/helpers/fileHelper.js");
    reactHotLoader.register(cleanFileContent, "cleanFileContent", "/home/travis/build/bakdata/conquery/frontend/lib/js/common/helpers/fileHelper.js");
    reactHotLoader.register(checkFileType, "checkFileType", "/home/travis/build/bakdata/conquery/frontend/lib/js/common/helpers/fileHelper.js");
    reactHotLoader.register(stripFileName, "stripFileName", "/home/travis/build/bakdata/conquery/frontend/lib/js/common/helpers/fileHelper.js");
    leaveModule(module);
})();

;