(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import 'redux-form';

import '../common/types/backend';
import InputMultiSelect from './InputMultiSelect';

var AsyncInputMultiSelect = function AsyncInputMultiSelect(_ref) {
  var label = _ref.label,
      options = _ref.options,
      disabled = _ref.disabled,
      tooltip = _ref.tooltip,
      startLoadingThreshold = _ref.startLoadingThreshold,
      onLoad = _ref.onLoad,
      isLoading = _ref.isLoading,
      input = _ref.input,
      onDropFiles = _ref.onDropFiles,
      allowDropFile = _ref.allowDropFile;
  return React.createElement(InputMultiSelect, {
    label: label,
    options: options,
    disabled: disabled,
    tooltip: tooltip,
    isLoading: isLoading,
    input: input,
    onInputChange: function onInputChange(value) {
      if (value.length >= startLoadingThreshold) onLoad(value);

      return value;
    },
    onDropFiles: onDropFiles,
    allowDropFile: allowDropFile
  });
};

var _default = AsyncInputMultiSelect;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(AsyncInputMultiSelect, 'AsyncInputMultiSelect', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/AsyncInputMultiSelect.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/AsyncInputMultiSelect.js');
  leaveModule(module);
})();

;