(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import classnames from 'classnames';

import CloseIconButton from '../button/CloseIconButton';
import Dropzone from './Dropzone';

var DropzoneList = function DropzoneList(props) {
  var FreeDropzone = Dropzone(null, props.acceptedDropTypes, props.onDrop);

  return React.createElement(
    'div',
    { className: classnames("dropzone-list", props.className) },
    props.label && React.createElement(
      'span',
      { className: 'input-label dropzone-list__label' },
      props.label
    ),
    props.items && props.items.length > 0 && React.createElement(
      'div',
      { className: 'dropzone-list__items' },
      props.items.map(function (item, i) {
        return React.createElement(
          'div',
          { key: i, className: classnames("dropzone-list__item", props.itemClassName) },
          React.createElement(CloseIconButton, {
            className: 'dropzone-list__remove-item-btn',
            onClick: function onClick() {
              return props.onDelete(i);
            }
          }),
          item
        );
      })
    ),

    // allow at least one column
    (props.items && props.items.length === 0 || !props.disallowMultipleColumns) && React.createElement(FreeDropzone, {
      className: props.dropzoneClassName,
      containsItem: false,
      dropzoneText: props.dropzoneText
    })
  );
};

var _default = DropzoneList;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(DropzoneList, 'DropzoneList', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/DropzoneList.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/DropzoneList.js');
  leaveModule(module);
})();

;