(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import classnames from 'classnames';

import CloseIconButton from '../button/CloseIconButton';
import IconButton from '../button/IconButton';

var DynamicInputGroup = function DynamicInputGroup(props) {
  return React.createElement(
    'div',
    { className: classnames("dynamic-input-group", props.className) },
    props.label && React.createElement(
      'span',
      { className: 'input-label dynamic-input-group__label' },
      props.label
    ),
    props.items.map(function (item, idx) {
      return React.createElement(
        'div',
        { key: idx, className: 'dynamic-input-group__item' },
        item,
        React.createElement(CloseIconButton, {
          className: 'dynamic-input-group__item__remove-btn',
          onClick: function onClick() {
            return props.onRemoveClick(idx);
          }
        })
      );
    }),
    React.createElement(IconButton, {
      className: 'btn--icon btn--transparent btn--small dynamic-input-group__add-btn',
      iconClassName: 'fa-plus',
      type: 'button',
      onClick: props.onAddClick
    })
  );
};

var _default = DynamicInputGroup;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(DynamicInputGroup, 'DynamicInputGroup', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/DynamicInputGroup.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/DynamicInputGroup.js');
  leaveModule(module);
})();

;