(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';

import { Tags } from '../tags';
import EditableTagsForm from './EditableTagsForm';

var EditableTags = function EditableTags(props) {
  return props.editing ? React.createElement(EditableTagsForm, {
    className: classnames(props.className, "editable-tags", "editable-tags__form"),
    tags: props.tags,
    loading: props.loading,
    onSubmit: props.onSubmit,
    onCancel: props.onToggleEdit,
    availableTags: props.availableTags
  }) : !!props.tags && props.tags.length > 0 && React.createElement(
    'div',
    { className: classnames(props.className, "editable-tags") },
    React.createElement(
      'span',
      {
        onClick: props.onToggleEdit,
        className: 'editable-tags__edit-btn btn--icon edit-btn'
      },
      React.createElement('i', { className: 'fa fa-edit' })
    ),
    props.tagComponent || React.createElement(Tags, {
      className: 'editable-tags__tags',
      tags: props.tags
    })
  );
};

EditableTags.propTypes = {
  className: PropTypes.string,
  tags: PropTypes.arrayOf(PropTypes.string),
  editing: PropTypes.bool.isRequired,
  loading: PropTypes.bool.isRequired,
  tagComponent: PropTypes.element,
  onSubmit: PropTypes.func.isRequired,
  onToggleEdit: PropTypes.func.isRequired,
  availableTags: PropTypes.arrayOf(PropTypes.string)
};

var _default = EditableTags;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(EditableTags, 'EditableTags', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/EditableTags.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/EditableTags.js');
  leaveModule(module);
})();

;