var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import T from 'i18n-react';
import classnames from 'classnames';
import clickOutside from 'react-onclickoutside';

// A multi-select where new items can be created
import { Creatable as Select } from 'react-select';

var EditableTagsForm = function (_React$Component) {
  _inherits(EditableTagsForm, _React$Component);

  function EditableTagsForm(props) {
    _classCallCheck(this, EditableTagsForm);

    var _this = _possibleConstructorReturn(this, (EditableTagsForm.__proto__ || Object.getPrototypeOf(EditableTagsForm)).call(this, props));

    _this.handleChange = function (values, actionMeta) {
      _this.setState({ values: values });
    };

    _this.state = {
      values: props.tags && props.tags.map(function (t) {
        return { label: t, value: t };
      }) || []
    };
    return _this;
  }

  _createClass(EditableTagsForm, [{
    key: 'handleClickOutside',
    value: function handleClickOutside() {
      this.props.onCancel();
    }
  }, {
    key: '_onSubmit',
    value: function _onSubmit(e) {
      e.preventDefault();

      this.props.onSubmit(this.state.values.map(function (v) {
        return v.value;
      }));
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'form',
        {
          className: classnames('editable-tags-form', this.props.className),
          onSubmit: this._onSubmit.bind(this)
        },
        React.createElement(Select, {
          name: 'input',
          value: this.state.values,
          options: this.props.availableTags.map(function (t) {
            return { label: t, value: t };
          }),
          onChange: this.handleChange,
          isMulti: true,
          isClearable: true,
          autoFocus: true,
          placeholder: T.translate('reactSelect.tagPlaceholder'),
          noOptionsMessage: function noOptionsMessage() {
            return T.translate('reactSelect.noResults');
          }
        }),
        React.createElement(
          'button',
          {
            type: 'submit',
            className: 'editable-tags-form__btn btn btn--small btn--primary',
            disabled: this.props.loading
          },
          T.translate('common.save')
        )
      );
    }
  }, {
    key: '__reactstandin__regenerateByEval',
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);

  return EditableTagsForm;
}(React.Component);

;

EditableTagsForm.propTypes = {
  className: PropTypes.string,
  tags: PropTypes.arrayOf(PropTypes.string),
  loading: PropTypes.bool.isRequired,
  onSubmit: PropTypes.func.isRequired,
  onCancel: PropTypes.func.isRequired,
  availableTags: PropTypes.arrayOf(PropTypes.string)
};

var _default = clickOutside(EditableTagsForm);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(EditableTagsForm, 'EditableTagsForm', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/EditableTagsForm.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/EditableTagsForm.js');
  leaveModule(module);
})();

;