var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import T from 'i18n-react';
import Select from 'react-select';
import Dropzone from 'react-dropzone';
import classnames from 'classnames';
import 'redux-form';

import { isEmpty } from '../common/helpers';
import '../common/types/backend';
import InfoTooltip from '../tooltip/InfoTooltip';

var InputSelect = function InputSelect(props) {
  var allowDropFile = props.allowDropFile && !!props.onDropFiles;
  var input = props.input,
      options = props.options;

  var selected = options && options.filter(function (v) {
    return v.value === input.value;
  });
  var defaultValue = options && options.filter(function (v) {
    return v.value === input.defaultValue;
  });

  return React.createElement(
    'label',
    { className: classnames('input', {
        'input--value-changed': !isEmpty(input.value) && input.value !== input.defaultValue
      }) },
    React.createElement(
      'p',
      { className: classnames('input-label', {
          'input-label--disabled': !!props.disabled
        }) },
      props.label,
      props.tooltip && React.createElement(InfoTooltip, { text: props.tooltip })
    ),
    React.createElement(
      Dropzone,
      {
        disableClick: true,
        style: { position: "relative", display: "block", maxWidth: "300px" },
        activeClassName: allowDropFile ? 'dropzone--over' : '',
        className: allowDropFile ? 'dropzone' : '',
        onDrop: props.onDropFiles,
        disabled: !allowDropFile
      },
      React.createElement(Select, _extends({
        name: 'form-field',
        value: selected,
        defaultValue: defaultValue,
        options: options,
        isSearchable: false,
        onChange: function onChange(field) {
          return field ? input.onChange(field.value) : input.onChange(null);
        },
        isClearable: input.clearable,
        isDisabled: !!props.disabled,
        placeholder: T.translate('reactSelect.placeholder'),
        noOptionsMessage: function noOptionsMessage() {
          return T.translate('reactSelect.noResults');
        }
      }, props.selectProps, {
        ref: function ref(r) {
          if (!r) return;

          var select = r.select;
          // https://github.com/JedWatson/react-select/issues/2816#issuecomment-425280935
          if (!select.onInputBlurPatched) {
            var originalOnInputBlur = select.onInputBlur;
            select.onInputBlur = function (e) {
              if (select.menuListRef && select.menuListRef.contains(document.activeElement)) {
                select.inputRef.focus();
                return;
              }
              originalOnInputBlur(e);
            };
            select.onInputBlurPatched = true;
          }
        }
      }))
    )
  );
};

var _default = InputSelect;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(InputSelect, 'InputSelect', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/InputSelect.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/form-components/InputSelect.js');
  leaveModule(module);
})();

;