(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { tablesHaveActiveFilter } from './table';

export var nodeHasActiveFilters = function nodeHasActiveFilters(node) {
  var tables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : node.tables;
  return node.excludeTimestamps || node.includeSubnodes || nodeHasActiveTableFilters(node, tables) || nodeHasExludedTable(node, tables);
};

export var nodeHasActiveTableFilters = function nodeHasActiveTableFilters(node) {
  var tables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : node.tables;

  if (!tables) return false;
  return tablesHaveActiveFilter(tables);
};

export var nodeHasExludedTable = function nodeHasExludedTable(node) {
  var tables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : node.tables;

  if (!tables) return false;
  return tables.some(function (table) {
    return table.exclude;
  });
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(nodeHasActiveFilters, 'nodeHasActiveFilters', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/node.js');
  reactHotLoader.register(nodeHasActiveTableFilters, 'nodeHasActiveTableFilters', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/node.js');
  reactHotLoader.register(nodeHasExludedTable, 'nodeHasExludedTable', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/node.js');
  leaveModule(module);
})();

;