var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { isEmpty } from '../common/helpers';

export var tablesHaveActiveFilter = function tablesHaveActiveFilter(tables) {
  return tables.some(function (table) {
    return tableHasActiveFilters(table);
  });
};

export var tableHasActiveFilters = function tableHasActiveFilters(table) {
  return table.filters && table.filters.some(function (filter) {
    return !isEmpty(filter.value) && filter.value !== filter.defaultValue;
  });
};

export var resetAllFiltersInTables = function resetAllFiltersInTables(tables) {
  return (tables || []).map(function (table) {
    var filters = table.filters ? table.filters.map(function (filter) {
      return _extends({}, filter, {
        value: filter.defaultValue,
        formattedValue: undefined
      });
    }) : null;

    return _extends({}, table, {
      filters: filters,
      exclude: false
    });
  });
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(tablesHaveActiveFilter, 'tablesHaveActiveFilter', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/table.js');
  reactHotLoader.register(tableHasActiveFilters, 'tableHasActiveFilters', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/table.js');
  reactHotLoader.register(resetAllFiltersInTables, 'resetAllFiltersInTables', '/home/travis/build/bakdata/conquery/frontend/lib/js/model/table.js');
  leaveModule(module);
})();

;