var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import { combineReducers } from 'redux';

import { CLICK_PANE_TAB } from './actionTypes';

// Keep a map of React components for the available tabs outside the Redux state
var registerRightPaneTabComponents = function registerRightPaneTabComponents(components) {
  window.rightPaneTabComponents = components;
};

export var getRightPaneTabComponent = function getRightPaneTabComponent(tab) {
  return window.rightPaneTabComponents[tab] || null;
};

export var buildPanesReducer = function buildPanesReducer(availableTabs) {
  var tabs = Object.values(availableTabs);

  // Collect reducers
  var tabsReducers = Object.assign.apply(Object, [{}].concat(_toConsumableArray(tabs.map(function (tab) {
    return _defineProperty({}, tab.description.key, tab.reducer);
  }))));

  // Collect components
  var tabsComponents = Object.assign.apply(Object, [{}].concat(_toConsumableArray(tabs.map(function (tab) {
    return _defineProperty({}, tab.description.key, tab.component);
  }))));
  registerRightPaneTabComponents(tabsComponents);

  var defaultTab = tabs.length ? tabs.sort(function (a, b) {
    return a.description.order - b.description.order;
  })[0] : null;

  var initialState = {
    left: {
      activeTab: 'categoryTrees',
      tabs: [{ label: 'leftPane.categoryTrees', key: 'categoryTrees', order: 0 }, { label: 'leftPane.previousQueries', key: 'previousQueries', order: 1 }]
    },
    right: {
      activeTab: defaultTab.description.key
    }
  };

  var rightPaneTabsReducer = combineReducers(tabsReducers);

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
      case CLICK_PANE_TAB:
        var _action$payload = action.payload,
            paneType = _action$payload.paneType,
            tab = _action$payload.tab;


        return _extends({}, state, _defineProperty({}, paneType, _extends({}, state[paneType], {
          activeTab: tab
        })));
      default:
        return _extends({}, state, {
          right: _extends({}, state.right, {
            tabs: rightPaneTabsReducer(state.right.tabs, action)
          })
        });
    }
  };
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(registerRightPaneTabComponents, 'registerRightPaneTabComponents', '/home/travis/build/bakdata/conquery/frontend/lib/js/pane/reducer.js');
  reactHotLoader.register(getRightPaneTabComponent, 'getRightPaneTabComponent', '/home/travis/build/bakdata/conquery/frontend/lib/js/pane/reducer.js');
  reactHotLoader.register(buildPanesReducer, 'buildPanesReducer', '/home/travis/build/bakdata/conquery/frontend/lib/js/pane/reducer.js');
  leaveModule(module);
})();

;