(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';

import { connect } from 'react-redux';
import classnames from 'classnames';

import { setPreviousQueriesFilter } from './actions';

var PreviousQueriesFilterButton = function PreviousQueriesFilterButton(props) {
  return React.createElement(
    'button',
    {
      className: classnames('previous-queries-filter-button', 'previous-queries-filter-button--' + props.value, {
        'previous-queries-filter-button--selected': props.selectedFilter === props.value
      }),
      onClick: function onClick() {
        return props.setFilter(props.value);
      }
    },
    props.text
  );
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    selectedFilter: state.previousQueriesFilter
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setFilter: function setFilter(filter) {
      return dispatch(setPreviousQueriesFilter(filter));
    }
  };
};

var _default = connect(mapStateToProps, mapDispatchToProps)(PreviousQueriesFilterButton);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(PreviousQueriesFilterButton, 'PreviousQueriesFilterButton', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/filter/PreviousQueriesFilterButton.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/filter/PreviousQueriesFilterButton.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/filter/PreviousQueriesFilterButton.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/filter/PreviousQueriesFilterButton.js');
  leaveModule(module);
})();

;