var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';

import { loadPreviousQueries } from './actions';
import { selectPreviousQueries } from './selector';
import PreviousQueries from './PreviousQueries';

var PreviousQueriesContainer = function PreviousQueriesContainer(props) {
  return React.createElement(PreviousQueries, {
    datasetId: props.datasetId,
    queries: props.queries,
    loading: props.loading,
    error: props.error,
    loadQueries: props.loadQueries
  });
};

PreviousQueriesContainer.propTypes = {
  datasetId: PropTypes.string.isRequired,
  queries: PropTypes.array.isRequired,
  loading: PropTypes.bool,
  error: PropTypes.string,
  loadQueries: PropTypes.func.isRequired
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    queries: selectPreviousQueries(state.previousQueries.queries, state.previousQueriesSearch, state.previousQueriesFilter),
    loading: state.previousQueries.loading,
    error: state.previousQueries.error
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    loadQueries: function loadQueries(datasetId) {
      return dispatch(loadPreviousQueries(datasetId));
    }
  };
};

var mergeProps = function mergeProps(stateProps, dispatchProps, ownProps) {
  return _extends({}, ownProps, stateProps, dispatchProps, {
    loadQueries: function loadQueries() {
      return dispatchProps.loadQueries(ownProps.datasetId);
    }
  });
};

var _default = connect(mapStateToProps, mapDispatchToProps, mergeProps)(PreviousQueriesContainer);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(PreviousQueriesContainer, 'PreviousQueriesContainer', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueriesContainer.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueriesContainer.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueriesContainer.js');
  reactHotLoader.register(mergeProps, 'mergeProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueriesContainer.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueriesContainer.js');
  leaveModule(module);
})();

;