(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { connect } from 'react-redux';
import { Tags } from '../../tags';

import { addTagToPreviousQueriesSearch } from '../search/actions';

var tagContainsAnySearch = function tagContainsAnySearch(tag, searches) {
  return searches.some(function (search) {
    return tag.toLowerCase().indexOf(search.toLowerCase()) !== -1;
  });
};

var mapStateToProps = function mapStateToProps(state, ownProps) {
  return {
    tags: (ownProps.tags || []).map(function (tag) {
      return {
        label: tag,
        isSelected: tagContainsAnySearch(tag, state.previousQueriesSearch)
      };
    })
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    onClickTag: function onClickTag(tag) {
      return dispatch(addTagToPreviousQueriesSearch(tag));
    }
  };
};

var _default = connect(mapStateToProps, mapDispatchToProps)(Tags);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(tagContainsAnySearch, 'tagContainsAnySearch', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueryTags.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueryTags.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueryTags.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/list/PreviousQueryTags.js');
  leaveModule(module);
})();

;