var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import T from 'i18n-react';
import ReactDropzone from 'react-dropzone';

import { InfoTooltip } from '../../tooltip';

import { Modal } from '../../modal';
import { ErrorMessage } from '../../error-message';
import { CloseIconButton } from '../../button';
import UploadReport from './UploadReport';
import './reducer';

var UploadQueryResultsModal = function (_React$Component) {
  _inherits(UploadQueryResultsModal, _React$Component);

  function UploadQueryResultsModal(props) {
    _classCallCheck(this, UploadQueryResultsModal);

    var _this = _possibleConstructorReturn(this, (UploadQueryResultsModal.__proto__ || Object.getPrototypeOf(UploadQueryResultsModal)).call(this, props));

    _this.state = {
      file: null
    };
    return _this;
  }

  _createClass(UploadQueryResultsModal, [{
    key: '_onDrop',
    value: function _onDrop(acceptedFiles) {
      this.setState({ file: acceptedFiles[0] });
    }
  }, {
    key: '_onReset',
    value: function _onReset() {
      this.setState({ file: null });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        Modal,
        { closeModal: this.props.onCloseModal, doneButton: true },
        React.createElement(
          'div',
          { className: 'upload-query-results-modal' },
          React.createElement(InfoTooltip, {
            text: T.translate('uploadQueryResultsModal.formatInfo.text')
          }),
          React.createElement(
            'h3',
            { className: 'upload-query-results-modal__headline' },
            T.translate('uploadQueryResultsModal.headline')
          ),
          this.props.success && React.createElement(
            'div',
            { className: 'upload-query-results-modal__success' },
            React.createElement(
              'p',
              null,
              React.createElement('i', { className: 'fa fa-check-circle fa-5x' })
            ),
            React.createElement(
              'p',
              null,
              T.translate('uploadQueryResultsModal.previousQueryCreated')
            ),
            React.createElement(UploadReport, { report: this.props.success })
          ),
          !this.props.success && React.createElement(
            'div',
            null,
            this.state.file ? React.createElement(
              'p',
              null,
              React.createElement(CloseIconButton, {
                onClick: this._onReset.bind(this)
              }),
              this.state.file.name
            ) : React.createElement(
              ReactDropzone,
              {
                onDrop: this._onDrop.bind(this),
                className: 'upload-query-results-modal__dropzone',
                activeClassName: 'upload-query-results-modal__dropzone--accepting',
                rejectClassName: 'upload-query-results-modal__dropzone--rejecting'
              },
              T.translate('uploadQueryResultsModal.dropzone')
            ),
            this.props.error && React.createElement(
              'div',
              { className: 'upload-query-results-modal__error' },
              React.createElement(ErrorMessage, {
                message: this.props.error.message
              }),
              React.createElement(UploadReport, { report: this.props.error })
            ),
            React.createElement(
              'button',
              {
                type: 'button',
                className: 'btn btn--primary',
                disabled: !this.state.file,
                onClick: function onClick() {
                  return _this2.props.onUploadFile(_this2.state.file);
                }
              },
              this.props.loading && React.createElement('i', { className: 'fa fa-spinner' }),
              '  ',
              T.translate('uploadQueryResultsModal.upload')
            )
          )
        )
      );
    }
  }, {
    key: '__reactstandin__regenerateByEval',
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);

  return UploadQueryResultsModal;
}(React.Component);

;

var _default = UploadQueryResultsModal;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(UploadQueryResultsModal, 'UploadQueryResultsModal', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/upload/UploadQueryResultsModal.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/previous-queries/upload/UploadQueryResultsModal.js');
  leaveModule(module);
})();

;