var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';

import { connect } from 'react-redux';
import T from 'i18n-react';

import '../standard-query-editor/types';

import { MenuColumn } from './MenuColumn';
import { NodeDetailsView } from './NodeDetailsView';
import { TableFilterView } from './TableFilterView';
import { DescriptionColumn } from './DescriptionColumn';

import { createQueryNodeEditorActions } from './actions';

var QueryNodeEditor = function QueryNodeEditor(props) {
  var node = props.node,
      editorState = props.editorState;


  if (!node) return null;

  var selectedTable = !node.isPreviousQuery && editorState.selectedInputTableIdx != null ? node.tables[editorState.selectedInputTableIdx] : null;

  return React.createElement(
    'div',
    { className: 'query-node-editor' },
    React.createElement(
      'div',
      { className: 'query-node-editor__wrapper' },
      React.createElement(MenuColumn, props),
      editorState.detailsViewActive && React.createElement(NodeDetailsView, props),
      !editorState.detailsViewActive && selectedTable != null && React.createElement(TableFilterView, props),
      !editorState.detailsViewActive && React.createElement(DescriptionColumn, props),
      React.createElement(
        'button',
        {
          type: 'button',
          className: 'query-node-editor__close-button btn btn--transparent btn--small',
          onClick: function onClick() {
            editorState.onReset();props.onCloseModal();
          }
        },
        T.translate('common.done')
      )
    )
  );
};

export var createConnectedQueryNodeEditor = function createConnectedQueryNodeEditor(mapStateToProps, mapDispatchToProps, mergeProps) {
  var mapDispatchToPropsInternal = function mapDispatchToPropsInternal(dispatch, ownProps) {
    var externalDispatchProps = mapDispatchToProps ? mapDispatchToProps(dispatch, ownProps) : {};

    var _createQueryNodeEdito = createQueryNodeEditorActions(ownProps.type),
        setDetailsViewActive = _createQueryNodeEdito.setDetailsViewActive,
        toggleEditLabel = _createQueryNodeEdito.toggleEditLabel,
        setInputTableViewActive = _createQueryNodeEdito.setInputTableViewActive,
        setFocusedInput = _createQueryNodeEdito.setFocusedInput,
        reset = _createQueryNodeEdito.reset;

    return _extends({}, externalDispatchProps, {
      editorState: _extends({}, externalDispatchProps.editorState || {}, {
        onSelectDetailsView: function onSelectDetailsView() {
          return dispatch(setDetailsViewActive());
        },
        onToggleEditLabel: function onToggleEditLabel() {
          return dispatch(toggleEditLabel());
        },
        onSelectInputTableView: function onSelectInputTableView(tableIdx) {
          return dispatch(setInputTableViewActive(tableIdx));
        },
        onShowDescription: function onShowDescription(filterIdx) {
          return dispatch(setFocusedInput(filterIdx));
        },
        onReset: function onReset() {
          return dispatch(reset());
        }
      })
    });
  };

  var mergePropsInternal = function mergePropsInternal(stateProps, dispatchProps, ownProps) {
    var externalMergedProps = mergeProps ? mergeProps(stateProps, dispatchProps, ownProps) : _extends({}, ownProps, stateProps, dispatchProps);

    return _extends({}, externalMergedProps, {
      editorState: _extends({}, stateProps.editorState || {}, dispatchProps.editorState || {})
    });
  };

  return connect(mapStateToProps, mapDispatchToPropsInternal, mergePropsInternal)(QueryNodeEditor);
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(QueryNodeEditor, 'QueryNodeEditor', '/home/travis/build/bakdata/conquery/frontend/lib/js/query-node-editor/QueryNodeEditor.js');
  reactHotLoader.register(createConnectedQueryNodeEditor, 'createConnectedQueryNodeEditor', '/home/travis/build/bakdata/conquery/frontend/lib/js/query-node-editor/QueryNodeEditor.js');
  leaveModule(module);
})();

;