(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';

import ParameterTableFilters from './ParameterTableFilters';


export var TableFilterView = function TableFilterView(props) {
  var node = props.node,
      editorState = props.editorState;


  var selectedTable = node.tables[editorState.selectedInputTableIdx];

  return React.createElement(
    'div',
    { className: 'query-node-editor__large_column query-node-editor__column' },
    React.createElement(
      'h4',
      null,
      'Filter'
    ),
    React.createElement(
      'div',
      { className: 'query-node-editor__column_content' },
      React.createElement(ParameterTableFilters, {
        key: editorState.selectedInputTableIdx,
        filters: selectedTable.filters,
        onSetFilterValue: function onSetFilterValue(filterIdx, value, formattedValue) {
          return props.onSetFilterValue(editorState.selectedInputTableIdx, filterIdx, value, formattedValue);
        },
        onSwitchFilterMode: function onSwitchFilterMode(filterIdx, mode) {
          return props.onSwitchFilterMode(editorState.selectedInputTableIdx, filterIdx, mode);
        },
        onLoadFilterSuggestions: function onLoadFilterSuggestions(filterIdx, filterId, prefix) {
          return props.onLoadFilterSuggestions(props.datasetId, editorState.selectedInputTableIdx, selectedTable.id, node.tree, filterIdx, filterId, prefix);
        },
        suggestions: props.suggestions && props.suggestions[editorState.selectedInputTableIdx],
        onShowDescription: editorState.onShowDescription,
        onDropFiles: function onDropFiles(filterIdx, filterId, files) {
          return props.onDropFiles(props.datasetId, node.tree, editorState.selectedInputTableIdx, selectedTable.id, filterIdx, filterId, files);
        },
        currencyConfig: props.currencyConfig
      })
    )
  );
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(TableFilterView, 'TableFilterView', '/home/travis/build/bakdata/conquery/frontend/lib/js/query-node-editor/TableFilterView.js');
  leaveModule(module);
})();

;