(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { createActionTypes } from './actionTypes';

export var createQueryNodeEditorActions = function createQueryNodeEditorActions(type) {
  var _createActionTypes = createActionTypes(type),
      SET_DETAILS_VIEW_ACTIVE = _createActionTypes.SET_DETAILS_VIEW_ACTIVE,
      SET_INPUT_TABLE_VIEW_ACTIVE = _createActionTypes.SET_INPUT_TABLE_VIEW_ACTIVE,
      SET_FOCUSED_INPUT = _createActionTypes.SET_FOCUSED_INPUT,
      TOGGLE_EDIT_LABEL = _createActionTypes.TOGGLE_EDIT_LABEL,
      RESET = _createActionTypes.RESET,
      TOGGLE_INCLUDE_SUBNODES = _createActionTypes.TOGGLE_INCLUDE_SUBNODES;

  var setDetailsViewActive = function setDetailsViewActive() {
    return { type: SET_DETAILS_VIEW_ACTIVE };
  };
  var setInputTableViewActive = function setInputTableViewActive(tableIdx) {
    return { type: SET_INPUT_TABLE_VIEW_ACTIVE, tableIdx: tableIdx };
  };
  var setFocusedInput = function setFocusedInput(filterIdx) {
    return { type: SET_FOCUSED_INPUT, filterIdx: filterIdx };
  };
  var toggleEditLabel = function toggleEditLabel() {
    return { type: TOGGLE_EDIT_LABEL };
  };
  var reset = function reset() {
    return { type: RESET };
  };
  var toggleIncludeSubnodes = function toggleIncludeSubnodes() {
    return { type: TOGGLE_INCLUDE_SUBNODES };
  };

  return {
    setDetailsViewActive: setDetailsViewActive,
    setInputTableViewActive: setInputTableViewActive,
    setFocusedInput: setFocusedInput,
    toggleEditLabel: toggleEditLabel,
    reset: reset,
    toggleIncludeSubnodes: toggleIncludeSubnodes
  };
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(createQueryNodeEditorActions, 'createQueryNodeEditorActions', '/home/travis/build/bakdata/conquery/frontend/lib/js/query-node-editor/actions.js');
  leaveModule(module);
})();

;