var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { createActionTypes } from './actionTypes';

export var createQueryNodeEditorReducer = function createQueryNodeEditorReducer(type) {
  var initialState = {
    detailsViewActive: true,
    selectedInputTableIdx: 0,
    selectedInput: null,
    editingLabel: false
  };

  var _createActionTypes = createActionTypes(type),
      SET_DETAILS_VIEW_ACTIVE = _createActionTypes.SET_DETAILS_VIEW_ACTIVE,
      SET_INPUT_TABLE_VIEW_ACTIVE = _createActionTypes.SET_INPUT_TABLE_VIEW_ACTIVE,
      SET_FOCUSED_INPUT = _createActionTypes.SET_FOCUSED_INPUT,
      TOGGLE_EDIT_LABEL = _createActionTypes.TOGGLE_EDIT_LABEL,
      RESET = _createActionTypes.RESET;

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
      case SET_DETAILS_VIEW_ACTIVE:
        return _extends({}, state, {
          detailsViewActive: true
        });
      case SET_INPUT_TABLE_VIEW_ACTIVE:
        return _extends({}, state, {
          detailsViewActive: false,
          selectedInputTableIdx: action.tableIdx,
          selectedInput: null
        });
      case SET_FOCUSED_INPUT:
        return _extends({}, state, {
          selectedInput: action.filterIdx
        });
      case TOGGLE_EDIT_LABEL:
        return _extends({}, state, {
          editingLabel: !state.editingLabel
        });
      case RESET:
        return initialState;
      default:
        return state;
    }
  };
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(createQueryNodeEditorReducer, 'createQueryNodeEditorReducer', '/home/travis/build/bakdata/conquery/frontend/lib/js/query-node-editor/reducer.js');
  leaveModule(module);
})();

;