(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import classnames from 'classnames';
import ReactList from 'react-list';

var ScrollableList = function ScrollableList(props) {
  var renderItem = function renderItem(index, key) {
    return React.createElement(
      'div',
      { key: key, className: 'scrollable-list-item' },
      props.items[index]
    );
  };

  var itemHeight = 34; // pixels, as defined in scrollableList.sass

  // If the number of visible items is specified here,
  // make an additional element half-visible at the end to indicate
  // that the list is scrollable
  var style = props.maxVisibleItems ? { maxHeight: (props.maxVisibleItems + 0.5) * itemHeight + 'px' } : {};

  return React.createElement(
    'div',
    {
      className: classnames('scrollable-list', {
        'scrollable-list--full-width': !!props.fullWidth,
        'scrollable-list--min-width': !!props.minWidth
      }),
      style: style
    },
    React.createElement(ReactList, {
      itemRenderer: renderItem,
      length: props.items ? props.items.length : 0,
      type: 'uniform' })
  );
};

var _default = ScrollableList;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(ScrollableList, 'ScrollableList', '/home/travis/build/bakdata/conquery/frontend/lib/js/scrollable-list/ScrollableList.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/scrollable-list/ScrollableList.js');
  leaveModule(module);
})();

;