(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import classnames from 'classnames';

var SelectableLabel = function SelectableLabel(props) {
  return React.createElement(
    'span',
    { className: classnames(props.className, "selectable-label", {
        "selectable-label--selected": props.isSelected
      }) },
    props.label
  );
};

SelectableLabel.propTypes = {
  className: PropTypes.string,
  label: PropTypes.string.isRequired,
  isSelected: PropTypes.bool.isRequired
};

var labelContainsAnySearch = function labelContainsAnySearch(label, searches) {
  return searches.some(function (search) {
    return label.toLowerCase().indexOf(search.toLowerCase()) !== -1;
  });
};

var mapStateToProps = function mapStateToProps(state, ownProps) {
  return {
    isSelected: labelContainsAnySearch(ownProps.label, state.previousQueriesSearch)
  };
};

var _default = connect(mapStateToProps)(SelectableLabel);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(SelectableLabel, 'SelectableLabel', '/home/travis/build/bakdata/conquery/frontend/lib/js/selectable-label/SelectableLabel.js');
  reactHotLoader.register(labelContainsAnySearch, 'labelContainsAnySearch', '/home/travis/build/bakdata/conquery/frontend/lib/js/selectable-label/SelectableLabel.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/selectable-label/SelectableLabel.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/selectable-label/SelectableLabel.js');
  leaveModule(module);
})();

;