(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import T from 'i18n-react';

import { IconButton } from '../button';

import { clearQuery as _clearQuery } from './actions';

var QueryClearButton = function QueryClearButton(props) {
  return props.isVisible && React.createElement(
    'div',
    { className: 'query-clear-button' },
    React.createElement(IconButton, {
      onClick: props.clearQuery,
      className: 'btn btn--small btn--transparent',
      label: T.translate("common.clear"),
      iconClassName: 'fa-trash-o'
    })
  );
};

QueryClearButton.propTypes = {
  clearQuery: PropTypes.func.isRequired,
  isVisible: PropTypes.bool.isRequired
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    isVisible: state.panes.right.tabs.queryEditor.query.length !== 0
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    clearQuery: function clearQuery() {
      return dispatch(_clearQuery());
    }
  };
};

var ConnectedQueryClearButton = connect(mapStateToProps, mapDispatchToProps)(QueryClearButton);
export { ConnectedQueryClearButton as QueryClearButton };
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(QueryClearButton, 'QueryClearButton', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryClearButton.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryClearButton.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryClearButton.js');
  reactHotLoader.register(ConnectedQueryClearButton, 'ConnectedQueryClearButton', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryClearButton.js');
  leaveModule(module);
})();

;