(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import T from 'i18n-react';
import { CloseIconButton } from '../button';

var QueryGroupActions = function QueryGroupActions(props) {
  return React.createElement(
    'div',
    { className: 'query-group__actions' },
    React.createElement(
      'div',
      { className: 'query-group__actions--left' },
      React.createElement(
        'span',
        {
          className: 'query-group__action ' + props.excludeActiveClass + ' btn--icon query-group__exclude-btn',
          onClick: props.onExcludeClick
        },
        React.createElement('i', {
          className: 'query-group__exclude-icon fa fa-ban'
        }),
        ' ',
        T.translate('queryEditor.exclude')
      ),
      React.createElement(
        'span',
        {
          className: 'query-group__action ' + props.dateActiveClass + ' btn--icon query-group__date-btn',
          onClick: props.onDateClick
        },
        React.createElement('i', {
          className: 'query-group__date-icon fa fa-calendar-o'
        }),
        ' ',
        T.translate('queryEditor.date')
      )
    ),
    React.createElement(
      'div',
      { className: 'query-group__actions--right' },
      React.createElement(CloseIconButton, {
        className: 'query-group__action',
        onClick: props.onDeleteGroup
      })
    )
  );
};

QueryGroupActions.propTypes = {
  excludeActiveClass: PropTypes.string,
  dateActiveClass: PropTypes.string,
  onExcludeClick: PropTypes.func.isRequired,
  onDeleteGroup: PropTypes.func.isRequired,
  onDateClick: PropTypes.func.isRequired
};

var _default = QueryGroupActions;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(QueryGroupActions, 'QueryGroupActions', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryGroupActions.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/QueryGroupActions.js');
  leaveModule(module);
})();

;