var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { connect } from 'react-redux';


import { QueryRunner } from '../query-runner';
import actions from '../app/actions';

var startStandardQuery = actions.startStandardQuery,
    stopStandardQuery = actions.stopStandardQuery;


function isButtonEnabled(state, ownProps) {
  return !!( // Return true or false even if all are undefined / null
  ownProps.datasetId !== null && !state.panes.right.tabs.queryEditor.queryRunner.startQuery.loading && !state.panes.right.tabs.queryEditor.queryRunner.stopQuery.loading && state.panes.right.tabs.queryEditor.query.length > 0);
}

var mapStateToProps = function mapStateToProps(state, ownProps) {
  return {
    queryRunner: state.panes.right.tabs.queryEditor.queryRunner,
    isButtonEnabled: isButtonEnabled(state, ownProps),
    isQueryRunning: !!state.panes.right.tabs.queryEditor.queryRunner.runningQuery,
    // Following ones only needed in dispatch functions
    queryId: state.panes.right.tabs.queryEditor.queryRunner.runningQuery,
    version: state.categoryTrees.version,
    query: state.panes.right.tabs.queryEditor.query
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    startQuery: function startQuery(datasetId, query, version) {
      return dispatch(startStandardQuery(datasetId, query, version));
    },
    stopQuery: function stopQuery(datasetId, queryId) {
      return dispatch(stopStandardQuery(datasetId, queryId));
    }
  };
};

var mergeProps = function mergeProps(stateProps, dispatchProps, ownProps) {
  return _extends({}, stateProps, dispatchProps, ownProps, {
    startQuery: function startQuery() {
      return dispatchProps.startQuery(ownProps.datasetId, stateProps.query, stateProps.version);
    },
    stopQuery: function stopQuery() {
      return dispatchProps.stopQuery(ownProps.datasetId, stateProps.queryId);
    }
  });
};

export var StandardQueryRunner = connect(mapStateToProps, mapDispatchToProps, mergeProps)(QueryRunner);
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(startStandardQuery, 'startStandardQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(stopStandardQuery, 'stopStandardQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(isButtonEnabled, 'isButtonEnabled', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(mergeProps, 'mergeProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  reactHotLoader.register(StandardQueryRunner, 'StandardQueryRunner', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/StandardQueryRunner.js');
  leaveModule(module);
})();

;