var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';

import '../pane';
import { createQueryRunnerReducer } from '../query-runner';

import { default as queryReducer } from './reducer';

import { QueryEditor } from './QueryEditor';
import { StandardQueryRunner } from './StandardQueryRunner';
import { QueryClearButton } from './QueryClearButton';

var StandardQueryEditor = function StandardQueryEditor(props) {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(QueryClearButton, null),
    React.createElement(QueryEditor, { selectedDatasetId: props.selectedDatasetId }),
    React.createElement(StandardQueryRunner, { datasetId: props.selectedDatasetId })
  );
};

var queryRunnerReducer = createQueryRunnerReducer('standard');

var standardQueryEditorTabDescription = {
  key: 'queryEditor',
  label: 'rightPane.queryEditor',
  order: 0
};

export var StandardQueryEditorTab = {
  description: standardQueryEditorTabDescription,
  reducer: function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : standardQueryEditorTabDescription;
    var action = arguments[1];
    return _extends({}, state, {
      query: queryReducer(state.query, action),
      queryRunner: queryRunnerReducer(state.queryRunner, action)
    });
  },
  component: StandardQueryEditor
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(StandardQueryEditor, 'StandardQueryEditor', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/index.js');
  reactHotLoader.register(queryRunnerReducer, 'queryRunnerReducer', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/index.js');
  reactHotLoader.register(standardQueryEditorTabDescription, 'standardQueryEditorTabDescription', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/index.js');
  reactHotLoader.register(StandardQueryEditorTab, 'StandardQueryEditorTab', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/index.js');
  leaveModule(module);
})();

;