var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import T from 'i18n-react';
import { difference } from 'lodash';

import { getConceptsByIdsWithTables, getConceptById } from '../category-trees/globalTreeStoreHelper';

import { isEmpty, stripObject } from '../common/helpers';

import '../common/types/backend';

import { resetAllFiltersInTables } from '../model/table';

import { QUERY_GROUP_MODAL_SET_MIN_DATE, QUERY_GROUP_MODAL_SET_MAX_DATE, QUERY_GROUP_MODAL_RESET_ALL_DATES, QUERY_GROUP_MODAL_SET_TOUCHED } from '../query-group-modal/actionTypes';

import { LOAD_PREVIOUS_QUERY_START, LOAD_PREVIOUS_QUERY_SUCCESS, LOAD_PREVIOUS_QUERY_ERROR, RENAME_PREVIOUS_QUERY_SUCCESS } from '../previous-queries/list/actionTypes';

import { UPLOAD_CONCEPT_LIST_MODAL_ACCEPT } from '../upload-concept-list-modal/actionTypes';

import { INTEGER_RANGE } from '../form-components';

import { DROP_AND_NODE, DROP_OR_NODE, DELETE_NODE, DELETE_GROUP, TOGGLE_EXCLUDE_GROUP, LOAD_QUERY, CLEAR_QUERY, EXPAND_PREVIOUS_QUERY, SELECT_NODE_FOR_EDITING, DESELECT_NODE, UPDATE_NODE_LABEL, ADD_CONCEPT_TO_NODE, REMOVE_CONCEPT_FROM_NODE, TOGGLE_TABLE, SET_FILTER_VALUE, RESET_ALL_FILTERS, SWITCH_FILTER_MODE, TOGGLE_TIMESTAMPS, LOAD_FILTER_SUGGESTIONS_START, LOAD_FILTER_SUGGESTIONS_SUCCESS, LOAD_FILTER_SUGGESTIONS_ERROR, SET_RESOLVED_FILTER_VALUES, TOGGLE_INCLUDE_SUBNODES } from './actionTypes';

var initialState = [];

var filterItem = function filterItem(item) {
  // This sort of mapping might be a problem when adding new optional properties to
  // either Nodes or Queries: Flow won't complain when we omit those optional
  // properties here. But we can't use a spread operator either...

  if (item.isPreviousQuery) return {
    label: item.label,
    excludeTimestamps: item.excludeTimestamps,
    loading: item.loading,
    error: item.error,

    id: item.id,
    // eslint-disable-next-line no-use-before-define
    query: item.query,
    isPreviousQuery: item.isPreviousQuery
  };else return {
    ids: item.ids,
    tables: item.tables,
    tree: item.tree,

    label: item.label,
    excludeTimestamps: item.excludeTimestamps,
    loading: item.loading,
    error: item.error,

    isPreviousQuery: item.isPreviousQuery
  };
};

var setGroupProperties = function setGroupProperties(node, andIdx, properties) {
  return [].concat(_toConsumableArray(node.slice(0, andIdx)), [_extends({}, node[andIdx], properties)], _toConsumableArray(node.slice(andIdx + 1)));
};

var setElementProperties = function setElementProperties(node, andIdx, orIdx, properties) {
  var groupProperties = {
    elements: [].concat(_toConsumableArray(node[andIdx].elements.slice(0, orIdx)), [_extends({}, node[andIdx].elements[orIdx], properties)], _toConsumableArray(node[andIdx].elements.slice(orIdx + 1)))
  };

  return setGroupProperties(node, andIdx, groupProperties);
};

var setAllElementsProperties = function setAllElementsProperties(node, properties) {
  return node.map(function (group) {
    return _extends({}, group, {
      elements: group.elements.map(function (element) {
        return _extends({}, element, properties);
      })
    });
  });
};

var dropAndNode = function dropAndNode(state, action) {
  var group = state[state.length - 1];
  var dateRangeOfLastGroup = group ? group.dateRange : null;
  var _action$payload = action.payload,
      item = _action$payload.item,
      _action$payload$dateR = _action$payload.dateRange,
      dateRange = _action$payload$dateR === undefined ? dateRangeOfLastGroup : _action$payload$dateR;


  var nextState = [].concat(_toConsumableArray(state), [{
    elements: [filterItem(item)],
    dateRange: dateRange
  }]);

  return item.moved ? deleteNode(nextState, { payload: { andIdx: item.andIdx, orIdx: item.orIdx } }) : nextState;
};

var dropOrNode = function dropOrNode(state, action) {
  var _action$payload2 = action.payload,
      item = _action$payload2.item,
      andIdx = _action$payload2.andIdx;


  var nextState = [].concat(_toConsumableArray(state.slice(0, andIdx)), [_extends({}, state[andIdx], {
    elements: [filterItem(item)].concat(_toConsumableArray(state[andIdx].elements))
  })], _toConsumableArray(state.slice(andIdx + 1)));

  return item.moved ? item.andIdx === andIdx ? deleteNode(nextState, { payload: { andIdx: item.andIdx, orIdx: item.orIdx + 1 } }) : deleteNode(nextState, { payload: { andIdx: item.andIdx, orIdx: item.orIdx } }) : nextState;
};

// Delete a single Node (concept inside a group)
var deleteNode = function deleteNode(state, action) {
  var _action$payload3 = action.payload,
      andIdx = _action$payload3.andIdx,
      orIdx = _action$payload3.orIdx;


  return [].concat(_toConsumableArray(state.slice(0, andIdx)), [_extends({}, state[andIdx], {
    elements: [].concat(_toConsumableArray(state[andIdx].elements.slice(0, orIdx)), _toConsumableArray(state[andIdx].elements.slice(orIdx + 1)))
  })], _toConsumableArray(state.slice(andIdx + 1))).filter(function (and) {
    return !!and.elements && and.elements.length > 0;
  });
};

var deleteGroup = function deleteGroup(state, action) {
  var andIdx = action.payload.andIdx;


  return [].concat(_toConsumableArray(state.slice(0, andIdx)), _toConsumableArray(state.slice(andIdx + 1)));
};

var toggleExcludeGroup = function toggleExcludeGroup(state, action) {
  var andIdx = action.payload.andIdx;


  return [].concat(_toConsumableArray(state.slice(0, andIdx)), [_extends({}, state[andIdx], {
    exclude: state[andIdx].exclude ? undefined : true
  })], _toConsumableArray(state.slice(andIdx + 1)));
};

var loadQuery = function loadQuery(state, action) {
  // In case there is no query, keep state the same
  if (!action.payload.query) return state;

  return action.payload.query;
};

var updateNodeTable = function updateNodeTable(state, andIdx, orIdx, tableIdx, table) {
  var node = state[andIdx].elements[orIdx];
  var tables = [].concat(_toConsumableArray(node.tables.slice(0, tableIdx)), [table], _toConsumableArray(node.tables.slice(tableIdx + 1)));

  return updateNodeTables(state, andIdx, orIdx, tables);
};

var updateNodeTables = function updateNodeTables(state, andIdx, orIdx, tables) {
  return setElementProperties(state, andIdx, orIdx, { tables: tables });
};

var toggleNodeTable = function toggleNodeTable(state, action) {
  var _action$payload4 = action.payload,
      tableIdx = _action$payload4.tableIdx,
      isExcluded = _action$payload4.isExcluded;


  var nodePosition = selectEditedNode(state);
  if (!nodePosition) return state;

  var andIdx = nodePosition.andIdx,
      orIdx = nodePosition.orIdx;

  var node = state[andIdx].elements[orIdx];
  var table = _extends({}, node.tables[tableIdx], {
    exclude: isExcluded
  });

  return updateNodeTable(state, andIdx, orIdx, tableIdx, table);
};

var selectEditedNode = function selectEditedNode(state) {
  var selectedNodes = state.reduce(function (acc, group, andIdx) {
    return [].concat(_toConsumableArray(acc), _toConsumableArray(group.elements.map(function (element, orIdx) {
      return { andIdx: andIdx, orIdx: orIdx, element: element };
    })));
  }, []).filter(function (_ref) {
    var element = _ref.element;
    return element.isEditing;
  }).map(function (_ref2) {
    var andIdx = _ref2.andIdx,
        orIdx = _ref2.orIdx;
    return { andIdx: andIdx, orIdx: orIdx };
  });

  return selectedNodes.length ? selectedNodes[0] : null;
};

var setNodeFilterProperties = function setNodeFilterProperties(state, action, obj) {
  var _action$payload5 = action.payload,
      tableIdx = _action$payload5.tableIdx,
      filterIdx = _action$payload5.filterIdx;


  var node = selectEditedNode(state);
  if (!node) return state;

  var andIdx = node.andIdx,
      orIdx = node.orIdx;

  var table = state[andIdx].elements[orIdx].tables[tableIdx];
  var filters = table.filters;


  if (!filters) return state;

  var filter = filters[filterIdx];

  // Go through the keys and set them to undefined if they're empty values
  // or empty objects
  var properties = stripObject(obj);

  if ('options' in properties) {
    // The properties object contains an 'options' key, but its value might
    // be undefined (because of stripObject above)
    var newOptions = properties.options || filter.options || [];
    properties.options = newOptions.reduce(function (options, currentOption) {
      return options.find(function (x) {
        return x.value === currentOption.value;
      }) ? options : [].concat(_toConsumableArray(options), [currentOption]);
    }, []);
  }

  if (properties.value === undefined && filter.defaultValue) properties.value = filter.defaultValue;

  var newTable = _extends({}, table, {
    filters: [].concat(_toConsumableArray(filters.slice(0, filterIdx)), [_extends({}, filter, properties)], _toConsumableArray(filters.slice(filterIdx + 1)))
  });

  return updateNodeTable(state, andIdx, orIdx, tableIdx, newTable);
};

var setNodeFilterValue = function setNodeFilterValue(state, action) {
  var _action$payload6 = action.payload,
      value = _action$payload6.value,
      formattedValue = _action$payload6.formattedValue,
      options = _action$payload6.options;


  return setNodeFilterProperties(state, action, { value: value, formattedValue: formattedValue, options: options });
};

var switchNodeFilterMode = function switchNodeFilterMode(state, action) {
  var mode = action.payload.mode;


  return setNodeFilterProperties(state, action, {
    mode: mode,
    value: null,
    formattedValue: null
  });
};

var resetNodeAllFilters = function resetNodeAllFilters(state, action) {
  var nodeIdx = selectEditedNode(state);
  if (!nodeIdx) return state;

  var andIdx = nodeIdx.andIdx,
      orIdx = nodeIdx.orIdx;

  var node = state[andIdx].elements[orIdx];

  var newState = setElementProperties(state, andIdx, orIdx, { excludeTimestamps: false });

  if (!node.tables) return newState;

  var tables = resetAllFiltersInTables(node.tables);
  return updateNodeTables(newState, andIdx, orIdx, tables);
};

var setGroupDate = function setGroupDate(state, action, minOrMax) {
  var _action$payload7 = action.payload,
      andIdx = _action$payload7.andIdx,
      date = _action$payload7.date;

  // Calculate next daterange

  var tmpDateRange = _extends({}, state[andIdx].dateRange, _defineProperty({}, minOrMax, date));
  // Make sure it has either min or max set, otherwise "delete" the key
  // by setting to undefined
  var dateRange = tmpDateRange.min || tmpDateRange.max ? tmpDateRange : undefined;

  return setGroupProperties(state, andIdx, { dateRange: dateRange });
};

var resetGroupDates = function resetGroupDates(state, action) {
  var andIdx = action.payload.andIdx;


  return setGroupProperties(state, andIdx, { dateRange: null });
};

var setGroupTouched = function setGroupTouched(state, action) {
  var _action$payload8 = action.payload,
      andIdx = _action$payload8.andIdx,
      field = _action$payload8.field;


  return setGroupProperties(state, andIdx, { touched: _defineProperty({}, field, true) });
};
// Merges filter values from `table` into declared filters from `savedTable`
//
// `savedTable` may define filters, but it won't have any filter values,
// since `savedTables` comes from a `savedConcept` in a `categoryTree`. Such a
// `savedConcept` is never modified and only declares possible filters.
// Since `table` comes from a previous query, it may have set filter values
// if so, we will need to merge them in.
var mergeFiltersFromSavedConcept = function mergeFiltersFromSavedConcept(savedTable, table) {
  if (!table || !table.filters) return savedTable.filters || null;

  if (!savedTable.filters) return null;

  return savedTable.filters.map(function (filter) {
    var tableFilter = table.filters.find(function (f) {
      return f.id === filter.id;
    }) || {};
    var mode = tableFilter.type === INTEGER_RANGE ? tableFilter.value && !isEmpty(tableFilter.value.exact) ? { mode: 'exact' } : { mode: 'range' } : {};

    return _extends({}, filter, tableFilter, mode);
  });
};

// Look for tables in the already savedConcept. If they were not included in the
// respective query concept, exclude them.
// Also, apply all necessary filters
var mergeTablesFromSavedConcept = function mergeTablesFromSavedConcept(savedConcept, concept) {
  return savedConcept.tables ? savedConcept.tables.map(function (savedTable) {
    // Find corresponding table in previous queryObject
    var table = concept.tables.find(function (t) {
      return t.id === savedTable.id;
    });
    var filters = mergeFiltersFromSavedConcept(savedTable, table);

    return _extends({}, savedTable, {
      exclude: !table,
      filters: filters
    });
  }) : [];
};

// Completely override all groups in the editor with the previous groups, but
// a) merge elements with concept data from category trees (esp. "tables")
// b) load nested previous queries contained in that query,
//    so they can also be expanded
var expandPreviousQuery = function expandPreviousQuery(state, action) {
  var _action$payload9 = action.payload,
      rootConcepts = _action$payload9.rootConcepts,
      groups = _action$payload9.groups;


  return groups.map(function (group) {
    return _extends({}, group, {
      elements: group.elements.map(function (element) {
        if (element.type === 'QUERY') {
          return _extends({}, element, {
            isPreviousQuery: true
          });
        } else {
          var ids = element.ids || [element.id];
          var lookupResult = getConceptsByIdsWithTables(ids, rootConcepts);

          if (!lookupResult) return _extends({}, element, {
            error: T.translate('queryEditor.couldNotExpandNode')
          });

          var tables = mergeTablesFromSavedConcept(lookupResult, element);
          var label = element.label || lookupResult.concepts[0].label;

          return _extends({}, element, {
            label: label,
            tables: tables,
            tree: lookupResult.root
          });
        }
      })
    });
  });
};

var findPreviousQueries = function findPreviousQueries(state, action) {
  // Find all nodes that are previous queries and have the correct id
  var queries = state.map(function (group, andIdx) {
    return group.elements.map(function (concept, orIdx) {
      return _extends({}, concept, { orIdx: orIdx });
    }).filter(function (concept) {
      return concept.isPreviousQuery && concept.id === action.payload.queryId;
    }).map(function (concept) {
      return {
        andIdx: andIdx,
        orIdx: concept.orIdx,
        node: concept
      };
    });
  }).filter(function (group) {
    return group.length > 0;
  });

  return [].concat.apply([], queries);
};

var updatePreviousQueries = function updatePreviousQueries(state, action, attributes) {
  var queries = findPreviousQueries(state, action);

  return queries.reduce(function (nextState, query) {
    var node = query.node,
        andIdx = query.andIdx,
        orIdx = query.orIdx;


    return [].concat(_toConsumableArray(nextState.slice(0, andIdx)), [_extends({}, nextState[andIdx], {
      elements: [].concat(_toConsumableArray(nextState[andIdx].elements.slice(0, orIdx)), [_extends({}, node, attributes)], _toConsumableArray(nextState[andIdx].elements.slice(orIdx + 1)))
    })], _toConsumableArray(nextState.slice(andIdx + 1)));
  }, state);
};

var loadPreviousQueryStart = function loadPreviousQueryStart(state, action) {
  return updatePreviousQueries(state, action, { loading: true });
};
var loadPreviousQuerySuccess = function loadPreviousQuerySuccess(state, action) {
  var label = action.payload.data.label ? { label: action.payload.data.label } : {};

  return updatePreviousQueries(state, action, _extends({}, label, {
    id: action.payload.data.id,
    loading: false,
    query: action.payload.data.query
  }));
};
var loadPreviousQueryError = function loadPreviousQueryError(state, action) {
  return updatePreviousQueries(state, action, { loading: false, error: action.payload.message });
};
var renamePreviousQuery = function renamePreviousQuery(state, action) {
  return updatePreviousQueries(state, action, { loading: false, label: action.payload.label });
};

var toggleTimestamps = function toggleTimestamps(state, action) {
  var isExcluded = action.payload.isExcluded;


  var nodePosition = selectEditedNode(state);
  if (!nodePosition) return state;

  var andIdx = nodePosition.andIdx,
      orIdx = nodePosition.orIdx;


  return setElementProperties(state, andIdx, orIdx, { excludeTimestamps: isExcluded });
};

var loadFilterSuggestionsStart = function loadFilterSuggestionsStart(state, action) {
  return setNodeFilterProperties(state, action, { isLoading: true });
};

var loadFilterSuggestionsSuccess = function loadFilterSuggestionsSuccess(state, action) {
  return setNodeFilterProperties(state, action, {
    isLoading: false,
    options: action.payload.suggestions
  });
};

var loadFilterSuggestionsError = function loadFilterSuggestionsError(state, action) {
  return setNodeFilterProperties(state, action, { isLoading: false, options: [] });
};

var createQueryNodeFromConceptListUploadResult = function createQueryNodeFromConceptListUploadResult(result) {
  var label = result.label,
      rootConcepts = result.rootConcepts,
      resolutionResult = result.resolutionResult;


  if (resolutionResult.conceptList) {
    var lookupResult = getConceptsByIdsWithTables(resolutionResult.conceptList, rootConcepts);

    if (lookupResult) return {
      label: label,
      ids: resolutionResult.conceptList,
      tables: lookupResult.tables,
      tree: lookupResult.root
    };
  } else if (resolutionResult.filter) {
    var _getConceptsByIdsWith = _slicedToArray(getConceptsByIdsWithTables([resolutionResult.selectedRoot], rootConcepts).concepts, 1),
        conceptRoot = _getConceptsByIdsWith[0];

    var resolvedTable = {
      id: resolutionResult.filter.tableId,
      filters: [{
        id: resolutionResult.filter.filterId,
        value: resolutionResult.filter.value,
        options: resolutionResult.filter.value
      }]
    };
    var tables = conceptRoot.tables.map(function (table) {
      return _extends({}, table, {
        filters: mergeFiltersFromSavedConcept(resolvedTable, table)
      });
    });

    return {
      label: label,
      ids: [conceptRoot.id],
      tables: tables,
      tree: conceptRoot.id
    };
  }

  return {
    label: label,
    ids: [],
    tables: [],
    tree: '',
    concepts: [],

    error: T.translate('queryEditor.couldNotInsertConceptList')
  };
};

var insertUploadedConceptList = function insertUploadedConceptList(state, action) {
  var parameters = action.data.parameters;

  var queryElement = createQueryNodeFromConceptListUploadResult(action.data);

  if (parameters.andIdx != null) return dropOrNode(state, { payload: { item: queryElement, andIdx: parameters.andIdx } });

  return dropAndNode(state, { payload: { item: queryElement, dateRange: parameters.dateRange } });
};

var selectNodeForEditing = function selectNodeForEditing(state, _ref3) {
  var _ref3$payload = _ref3.payload,
      andIdx = _ref3$payload.andIdx,
      orIdx = _ref3$payload.orIdx;

  return setElementProperties(state, andIdx, orIdx, { isEditing: true });
};

var deselectNode = function deselectNode(state, action) {
  return setAllElementsProperties(state, { isEditing: false });
};

var updateNodeLabel = function updateNodeLabel(state, action) {
  var node = selectEditedNode(state);
  if (!node) return state;

  var andIdx = node.andIdx,
      orIdx = node.orIdx;

  return setElementProperties(state, andIdx, orIdx, { label: action.label });
};

var addConceptToNode = function addConceptToNode(state, action) {
  var nodePosition = selectEditedNode(state);
  if (!nodePosition) return state;

  var andIdx = nodePosition.andIdx,
      orIdx = nodePosition.orIdx;

  var node = state[andIdx].elements[orIdx];
  return setElementProperties(state, andIdx, orIdx, {
    ids: [].concat(_toConsumableArray(action.concept.ids), _toConsumableArray(node.ids))
  });
};

var removeConceptFromNode = function removeConceptFromNode(state, action) {
  var nodePosition = selectEditedNode(state);
  if (!nodePosition) return state;

  var andIdx = nodePosition.andIdx,
      orIdx = nodePosition.orIdx;

  var node = state[andIdx].elements[orIdx];
  return setElementProperties(state, andIdx, orIdx, {
    ids: node.ids.filter(function (id) {
      return id !== action.conceptId;
    })
  });
};

var setResolvedFilterValues = function setResolvedFilterValues(state, action) {
  var _action$data = action.data,
      resolutionResult = _action$data.resolutionResult,
      parameters = _action$data.parameters;


  return setNodeFilterValue(state, {
    payload: {
      value: resolutionResult.filter.value,
      tableIdx: parameters.tableIdx,
      filterIdx: parameters.filterIdx,
      options: resolutionResult.filter.value
    }
  });
};

var toggleIncludeSubnodes = function toggleIncludeSubnodes(state, action) {
  var _groupProps$elements;

  var includeSubnodes = action.payload.includeSubnodes;


  var nodePosition = selectEditedNode(state);
  if (!nodePosition) return state;

  var andIdx = nodePosition.andIdx,
      orIdx = nodePosition.orIdx;


  var node = state[andIdx].elements[orIdx];

  var concept = getConceptById(node.ids);

  var childIds = [];
  var elements = concept.children.map(function (childId) {
    var child = getConceptById(childId);
    childIds.push(childId);
    return {
      ids: [childId],
      label: child.label,
      tables: node.tables,
      tree: node.tree
    };
  });

  var groupProps = {
    elements: [].concat(_toConsumableArray(state[andIdx].elements.slice(0, orIdx)), [_extends({}, state[andIdx].elements[orIdx], {
      includeSubnodes: includeSubnodes
    })], _toConsumableArray(state[andIdx].elements.slice(orIdx + 1)))
  };

  if (includeSubnodes) (_groupProps$elements = groupProps.elements).push.apply(_groupProps$elements, _toConsumableArray(elements));else groupProps.elements = groupProps.elements.filter(function (element) {
    return !(difference(element.ids, childIds).length === 0);
  });

  return setGroupProperties(state, andIdx, groupProps);
};

// Query is an array of "groups" (a AND b and c)
// where a, b, c are objects, that (can) have properites,
// like `dateRange` or `exclude`.
// But the main property is "elements" - an array of objects
// that contain at least an ID.
// An element may contain an array of tables that may
// either be excluded, or contain an array of filters with values.
//
// Example:
// [
//   {
//     elements: [
//       { id: 9, tables: [{ id: 1}] },
//       {
//         id: 10,
//         tables: [
//           { id: 213, exclude: true },
//           {
//             id: 452,
//             filters: [
//               { id: 52, type: 'INTEGER_RANGE', value: { min: 2, max: 3 } }
//               { id: 53, type: 'SELECT', value: "Some example filter value" }
//             ]
//           }
//         ]
//       }
//     ]
//   }, {
//     elements: [
//      {id: 6, tables: []}, {id: 7, tables: []}, {id: 5, tables: []}
//     ]
//   }
// ]
var query = function query() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case DROP_AND_NODE:
      return dropAndNode(state, action);
    case DROP_OR_NODE:
      return dropOrNode(state, action);
    case DELETE_NODE:
      return deleteNode(state, action);
    case DELETE_GROUP:
      return deleteGroup(state, action);
    case TOGGLE_EXCLUDE_GROUP:
      return toggleExcludeGroup(state, action);
    case LOAD_QUERY:
      return loadQuery(state, action);
    case CLEAR_QUERY:
      return initialState;
    case SELECT_NODE_FOR_EDITING:
      return selectNodeForEditing(state, action);
    case DESELECT_NODE:
      return deselectNode(state, action);
    case UPDATE_NODE_LABEL:
      return updateNodeLabel(state, action);
    case ADD_CONCEPT_TO_NODE:
      return addConceptToNode(state, action);
    case REMOVE_CONCEPT_FROM_NODE:
      return removeConceptFromNode(state, action);
    case TOGGLE_TABLE:
      return toggleNodeTable(state, action);
    case SET_FILTER_VALUE:
      return setNodeFilterValue(state, action);
    case RESET_ALL_FILTERS:
      return resetNodeAllFilters(state, action);
    case SWITCH_FILTER_MODE:
      return switchNodeFilterMode(state, action);
    case TOGGLE_TIMESTAMPS:
      return toggleTimestamps(state, action);
    case QUERY_GROUP_MODAL_SET_MIN_DATE:
      return setGroupDate(state, action, 'min');
    case QUERY_GROUP_MODAL_SET_MAX_DATE:
      return setGroupDate(state, action, 'max');
    case QUERY_GROUP_MODAL_RESET_ALL_DATES:
      return resetGroupDates(state, action);
    case QUERY_GROUP_MODAL_SET_TOUCHED:
      return setGroupTouched(state, action);
    case EXPAND_PREVIOUS_QUERY:
      return expandPreviousQuery(state, action);
    case LOAD_PREVIOUS_QUERY_START:
      return loadPreviousQueryStart(state, action);
    case LOAD_PREVIOUS_QUERY_SUCCESS:
      return loadPreviousQuerySuccess(state, action);
    case LOAD_PREVIOUS_QUERY_ERROR:
      return loadPreviousQueryError(state, action);
    case RENAME_PREVIOUS_QUERY_SUCCESS:
      return renamePreviousQuery(state, action);
    case LOAD_FILTER_SUGGESTIONS_START:
      return loadFilterSuggestionsStart(state, action);
    case LOAD_FILTER_SUGGESTIONS_SUCCESS:
      return loadFilterSuggestionsSuccess(state, action);
    case LOAD_FILTER_SUGGESTIONS_ERROR:
      return loadFilterSuggestionsError(state, action);
    case UPLOAD_CONCEPT_LIST_MODAL_ACCEPT:
      return insertUploadedConceptList(state, action);
    case SET_RESOLVED_FILTER_VALUES:
      return setResolvedFilterValues(state, action);
    case TOGGLE_INCLUDE_SUBNODES:
      return toggleIncludeSubnodes(state, action);
    default:
      return state;
  }
};

var _default = query;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(initialState, 'initialState', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(filterItem, 'filterItem', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setGroupProperties, 'setGroupProperties', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setElementProperties, 'setElementProperties', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setAllElementsProperties, 'setAllElementsProperties', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(dropAndNode, 'dropAndNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(dropOrNode, 'dropOrNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(deleteNode, 'deleteNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(deleteGroup, 'deleteGroup', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(toggleExcludeGroup, 'toggleExcludeGroup', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadQuery, 'loadQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(updateNodeTable, 'updateNodeTable', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(updateNodeTables, 'updateNodeTables', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(toggleNodeTable, 'toggleNodeTable', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(selectEditedNode, 'selectEditedNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setNodeFilterProperties, 'setNodeFilterProperties', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setNodeFilterValue, 'setNodeFilterValue', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(switchNodeFilterMode, 'switchNodeFilterMode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(resetNodeAllFilters, 'resetNodeAllFilters', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setGroupDate, 'setGroupDate', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(resetGroupDates, 'resetGroupDates', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setGroupTouched, 'setGroupTouched', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(mergeFiltersFromSavedConcept, 'mergeFiltersFromSavedConcept', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(mergeTablesFromSavedConcept, 'mergeTablesFromSavedConcept', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(expandPreviousQuery, 'expandPreviousQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(findPreviousQueries, 'findPreviousQueries', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(updatePreviousQueries, 'updatePreviousQueries', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadPreviousQueryStart, 'loadPreviousQueryStart', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadPreviousQuerySuccess, 'loadPreviousQuerySuccess', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadPreviousQueryError, 'loadPreviousQueryError', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(renamePreviousQuery, 'renamePreviousQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(toggleTimestamps, 'toggleTimestamps', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadFilterSuggestionsStart, 'loadFilterSuggestionsStart', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadFilterSuggestionsSuccess, 'loadFilterSuggestionsSuccess', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(loadFilterSuggestionsError, 'loadFilterSuggestionsError', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(createQueryNodeFromConceptListUploadResult, 'createQueryNodeFromConceptListUploadResult', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(insertUploadedConceptList, 'insertUploadedConceptList', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(selectNodeForEditing, 'selectNodeForEditing', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(deselectNode, 'deselectNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(updateNodeLabel, 'updateNodeLabel', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(addConceptToNode, 'addConceptToNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(removeConceptFromNode, 'removeConceptFromNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(setResolvedFilterValues, 'setResolvedFilterValues', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(toggleIncludeSubnodes, 'toggleIncludeSubnodes', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(query, 'query', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/standard-query-editor/reducer.js');
  leaveModule(module);
})();

;