(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import { applyMiddleware, compose, createStore } from 'redux';

import buildAppReducer from './app/reducers';
import { isProduction } from './environment';
import createMiddleware from './middleware';

export function makeStore(initialState, browserHistory, tabs) {
  var middleware = applyMiddleware.apply(undefined, _toConsumableArray(createMiddleware(browserHistory)));

  var enhancer = void 0;

  if (!isProduction()) enhancer = compose(middleware,
  // Use the Redux devtools extention, but only in development
  window.devToolsExtension ? window.devToolsExtension() : function (f) {
    return f;
  });else enhancer = compose(middleware);

  var store = createStore(buildAppReducer(tabs), initialState, enhancer);

  if (module.hot)
    // Enable Webpack hot module replacement for reducers
    module.hot.accept('./app/reducers', function () {
      var nextRootReducer = buildAppReducer(tabs);
      store.replaceReducer(nextRootReducer);
    });

  return store;
}
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(makeStore, 'makeStore', '/home/travis/build/bakdata/conquery/frontend/lib/js/store.js');
  leaveModule(module);
})();

;