(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import Tag from './Tag';

export var Tags = function Tags(props) {
  return !!props.tags && props.tags.length > 0 && React.createElement(
    'div',
    { className: props.className },
    props.tags.map(function (tag, i) {
      return React.createElement(Tag, {
        key: i,
        label: tag.label,
        isSelected: tag.isSelected,
        onClick: function onClick() {
          return props.onClickTag(tag.label);
        }
      });
    })
  );
};

Tags.propTypes = {
  className: PropTypes.string,
  tags: PropTypes.arrayOf(PropTypes.shape({
    label: PropTypes.string.isRequired,
    isSelected: PropTypes.bool
  })),
  onClickTag: PropTypes.func.isRequired
};

var _default = Tags;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(Tags, 'Tags', '/home/travis/build/bakdata/conquery/frontend/lib/js/tags/Tags.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/tags/Tags.js');
  leaveModule(module);
})();

;