(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import T from 'i18n-react';
import { IconButton } from '../button';
import { clearTimebasedQuery } from './actions';
import { anyConditionFilled } from './helpers';

var TimebasedQueryClearButton = function TimebasedQueryClearButton(props) {
  return React.createElement(
    'div',
    { className: 'query-clear-button' },
    React.createElement(IconButton, {
      onClick: props.clearQuery,
      className: 'btn btn--small btn--transparent',
      label: T.translate("common.clear"),
      iconClassName: 'fa-trash-o',
      disabled: !props.isEnabled
    })
  );
};

TimebasedQueryClearButton.propTypes = {
  clearQuery: PropTypes.func.isRequired,
  isEnabled: PropTypes.bool.isRequired
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    isEnabled: state.panes.right.tabs.timebasedQueryEditor.timebasedQuery.conditions.length > 1 || anyConditionFilled(state.panes.right.tabs.timebasedQueryEditor.timebasedQuery)
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    clearQuery: function clearQuery() {
      return dispatch(clearTimebasedQuery());
    }
  };
};

var _default = connect(mapStateToProps, mapDispatchToProps)(TimebasedQueryClearButton);

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(TimebasedQueryClearButton, 'TimebasedQueryClearButton', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryClearButton.js');
  reactHotLoader.register(mapStateToProps, 'mapStateToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryClearButton.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryClearButton.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryClearButton.js');
  leaveModule(module);
})();

;