(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import classnames from 'classnames';
import T from 'i18n-react';
import { DropTarget } from 'react-dnd';

import { PREVIOUS_QUERY, TIMEBASED_NODE } from '../common/constants/dndTypes';

import { removeTimebasedNode } from './actions';

var dropzoneTarget = {
  drop: function drop(props, monitor) {
    var item = monitor.getItem();

    var moved = item.moved;


    if (moved) {
      var conditionIdx = item.conditionIdx,
          resultIdx = item.resultIdx;


      props.onRemoveTimebasedNode(conditionIdx, resultIdx, moved);
      props.onDropNode(item.node, moved);
    } else {
      props.onDropNode(item, false);
    }
  }
};

function collect(connect, monitor) {
  return {
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver()
  };
}

var TimebasedQueryEditorDropzone = function TimebasedQueryEditorDropzone(props) {
  return props.connectDropTarget(React.createElement(
    'div',
    { className: 'timebased-query-editor-dropzone' },
    React.createElement(
      'div',
      { className: classnames('dropzone', {
          'dropzone--over': props.isOver
        }) },
      React.createElement(
        'p',
        { className: 'dropzone__text' },
        T.translate('dropzone.dragQuery')
      )
    )
  ));
};

TimebasedQueryEditorDropzone.propTypes = {
  connectDropTarget: PropTypes.func.isRequired,
  isOver: PropTypes.bool.isRequired,
  onDropNode: PropTypes.func.isRequired,
  onRemoveTimebasedNode: PropTypes.func.isRequired
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    onRemoveTimebasedNode: function onRemoveTimebasedNode(conditionIdx, resultIdx, moved) {
      return dispatch(removeTimebasedNode(conditionIdx, resultIdx, moved));
    }
  };
};

var _default = connect(function () {
  return {};
}, mapDispatchToProps)(DropTarget([PREVIOUS_QUERY, TIMEBASED_NODE], dropzoneTarget, collect)(TimebasedQueryEditorDropzone));

export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(dropzoneTarget, 'dropzoneTarget', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryEditorDropzone.js');
  reactHotLoader.register(collect, 'collect', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryEditorDropzone.js');
  reactHotLoader.register(TimebasedQueryEditorDropzone, 'TimebasedQueryEditorDropzone', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryEditorDropzone.js');
  reactHotLoader.register(mapDispatchToProps, 'mapDispatchToProps', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryEditorDropzone.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/TimebasedQueryEditorDropzone.js');
  leaveModule(module);
})();

;