(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import { DROP_TIMEBASED_NODE, REMOVE_TIMEBASED_NODE, SET_TIMEBASED_NODE_TIMESTAMP, SET_TIMEBASED_CONDITION_OPERATOR, SET_TIMEBASED_CONDITION_MIN_DAYS, SET_TIMEBASED_CONDITION_MAX_DAYS, SET_TIMEBASED_INDEX_RESULT, ADD_TIMEBASED_CONDITION, REMOVE_TIMEBASED_CONDITION, CLEAR_TIMEBASED_QUERY, SET_TIMEBASED_CONDITION_MIN_DAYS_OR_NO_EVENT, SET_TIMEBASED_CONDITION_MAX_DAYS_OR_NO_EVENT } from './actionTypes';

export var dropTimebasedNode = function dropTimebasedNode(conditionIdx, resultIdx, node, moved) {
  return {
    type: DROP_TIMEBASED_NODE,
    payload: { conditionIdx: conditionIdx, resultIdx: resultIdx, node: node, moved: moved }
  };
};

export var removeTimebasedNode = function removeTimebasedNode(conditionIdx, resultIdx, moved) {
  return {
    type: REMOVE_TIMEBASED_NODE,
    payload: { conditionIdx: conditionIdx, resultIdx: resultIdx, moved: moved }
  };
};

export var setTimebasedNodeTimestamp = function setTimebasedNodeTimestamp(conditionIdx, resultIdx, timestamp) {
  return {
    type: SET_TIMEBASED_NODE_TIMESTAMP,
    payload: { conditionIdx: conditionIdx, resultIdx: resultIdx, timestamp: timestamp }
  };
};

export var setTimebasedConditionOperator = function setTimebasedConditionOperator(conditionIdx, operator) {
  return {
    type: SET_TIMEBASED_CONDITION_OPERATOR,
    payload: { conditionIdx: conditionIdx, operator: operator }
  };
};

export var setTimebasedConditionMaxDays = function setTimebasedConditionMaxDays(conditionIdx, days) {
  return {
    type: SET_TIMEBASED_CONDITION_MAX_DAYS,
    payload: { conditionIdx: conditionIdx, days: days }
  };
};

export var setTimebasedConditionMinDays = function setTimebasedConditionMinDays(conditionIdx, days) {
  return {
    type: SET_TIMEBASED_CONDITION_MIN_DAYS,
    payload: { conditionIdx: conditionIdx, days: days }
  };
};

export var setTimebasedConditionMinDaysOrNoEvent = function setTimebasedConditionMinDaysOrNoEvent(conditionIdx, days) {
  return {
    type: SET_TIMEBASED_CONDITION_MIN_DAYS_OR_NO_EVENT,
    payload: { conditionIdx: conditionIdx, days: days }
  };
};

export var setTimebasedConditionMaxDaysOrNoEvent = function setTimebasedConditionMaxDaysOrNoEvent(conditionIdx, days) {
  return {
    type: SET_TIMEBASED_CONDITION_MAX_DAYS_OR_NO_EVENT,
    payload: { conditionIdx: conditionIdx, days: days }
  };
};

export var setTimebasedIndexResult = function setTimebasedIndexResult(indexResult) {
  return {
    type: SET_TIMEBASED_INDEX_RESULT,
    payload: { indexResult: indexResult }
  };
};

export var addTimebasedCondition = function addTimebasedCondition() {
  return { type: ADD_TIMEBASED_CONDITION };
};

export var removeTimebasedCondition = function removeTimebasedCondition(conditionIdx) {
  return {
    type: REMOVE_TIMEBASED_CONDITION,
    payload: { conditionIdx: conditionIdx }
  };
};

export var clearTimebasedQuery = function clearTimebasedQuery() {
  return { type: CLEAR_TIMEBASED_QUERY };
};
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(dropTimebasedNode, 'dropTimebasedNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(removeTimebasedNode, 'removeTimebasedNode', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedNodeTimestamp, 'setTimebasedNodeTimestamp', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedConditionOperator, 'setTimebasedConditionOperator', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedConditionMaxDays, 'setTimebasedConditionMaxDays', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedConditionMinDays, 'setTimebasedConditionMinDays', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedConditionMinDaysOrNoEvent, 'setTimebasedConditionMinDaysOrNoEvent', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedConditionMaxDaysOrNoEvent, 'setTimebasedConditionMaxDaysOrNoEvent', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(setTimebasedIndexResult, 'setTimebasedIndexResult', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(addTimebasedCondition, 'addTimebasedCondition', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(removeTimebasedCondition, 'removeTimebasedCondition', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  reactHotLoader.register(clearTimebasedQuery, 'clearTimebasedQuery', '/home/travis/build/bakdata/conquery/frontend/lib/js/timebased-query-editor/actions.js');
  leaveModule(module);
})();

;