(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

import React from 'react';
import ReactTooltip from 'react-tooltip';
import classnames from 'classnames';

var InfoTooltip = function InfoTooltip(props) {
  return React.createElement(
    'span',
    { className: classnames("info-tooltip", props.className) },
    React.createElement('i', {
      'data-tip': props.text,
      className: classnames({ 'fa fa-question-circle-o': props.symbol })
    }),
    React.createElement(ReactTooltip, {
      place: props.place,
      type: 'info',
      effect: 'solid',
      multiline: true
    })
  );
};

InfoTooltip.defaultProps = {
  symbol: true,
  place: 'right'
};

var _default = InfoTooltip;
export default _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(InfoTooltip, 'InfoTooltip', '/home/travis/build/bakdata/conquery/frontend/lib/js/tooltip/InfoTooltip.js');
  reactHotLoader.register(_default, 'default', '/home/travis/build/bakdata/conquery/frontend/lib/js/tooltip/InfoTooltip.js');
  leaveModule(module);
})();

;